blob: fc5d8f407b8a4bebd2d500fc5659eca88183eda9 [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Ollie Lho184a4042005-11-26 21:55:36 +000017PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000018
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000019###############################################################################
20# Defaults for the toolchain.
21
22# If you want to cross-compile, just run e.g.
23# make CC=i586-pc-msdosdjgpp-gcc
24# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000025#
26# Note for anyone editing this Makefile: gnumake will happily ignore any
27# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000028STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000029INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000030DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000031PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000032MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010033CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000034EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000035RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000036PKG_CONFIG ?= pkg-config
37BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000038
Stefan Taunerfd0d4132012-09-25 21:24:55 +000039# The following parameter changes the default programmer that will be used if there is no -p/--programmer
40# argument given when running flashrom. The predefined setting does not enable any default so that every
41# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
42# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
43# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
44# system attached to an external programmer while the default programmer is set to the internal programmer, and
45# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
46# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020047# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
48CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000049# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000051# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020052# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000053# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000054
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000055# If your compiler spits out excessive warnings, run make WARNERROR=no
56# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000057WARNERROR ?= yes
58
59ifeq ($(WARNERROR), yes)
60CFLAGS += -Werror
61endif
62
Stefan Taunere37735a2015-01-26 22:03:35 +000063ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000064PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000065override CPPFLAGS += -I$(LIBS_BASE)/include
66override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000067endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000068
Stefan Taunerbfb067b2016-01-07 18:13:07 +000069ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000070override PKG_CONFIG += --static
71override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072endif
73
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000074# Set LC_ALL=C to minimize influences of the locale.
75# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060076# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077LC_ALL=C
78export LC_ALL
79
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000080dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000081
82# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
83# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090084debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
85 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000086
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000087###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020088# Dependency handling.
89
90DEPENDS_ON_SERIAL := \
91 CONFIG_BUSPIRATE_SPI \
92 CONFIG_PONY_SPI \
93 CONFIG_SERPROG \
94
95DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020096 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +020097 CONFIG_INTERNAL \
98 CONFIG_NICINTEL_SPI \
99 CONFIG_OGP_SPI \
100 CONFIG_PONY_SPI \
101 CONFIG_RAYER_SPI \
102
103DEPENDS_ON_LIBPCI := \
104 CONFIG_ATAHPT \
105 CONFIG_ATAPROMISE \
106 CONFIG_ATAVIA \
107 CONFIG_DRKAISER \
108 CONFIG_GFXNVIDIA \
109 CONFIG_INTERNAL \
110 CONFIG_IT8212 \
111 CONFIG_NIC3COM \
112 CONFIG_NICINTEL \
113 CONFIG_NICINTEL_EEPROM \
114 CONFIG_NICINTEL_SPI \
115 CONFIG_NICNATSEMI \
116 CONFIG_NICREALTEK \
117 CONFIG_OGP_SPI \
118 CONFIG_SATAMV \
119 CONFIG_SATASII \
120
121DEPENDS_ON_LIBUSB1 := \
122 CONFIG_CH341A_SPI \
123 CONFIG_DEDIPROG \
124 CONFIG_DEVELOPERBOX_SPI \
125 CONFIG_DIGILENT_SPI \
126 CONFIG_PICKIT2_SPI \
127 CONFIG_RAIDEN_DEBUG_SPI \
128 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200129 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200130
131DEPENDS_ON_LIBFTDI := \
132 CONFIG_FT2232_SPI \
133 CONFIG_USBBLASTER_SPI \
134
135DEPENDS_ON_LIBJAYLINK := \
136 CONFIG_JLINK_SPI \
137
Nico Huberafca7ac2021-06-27 13:35:21 +0200138define mark_unsupported
139$(foreach p,$1, \
140 $(if $(filter $($(p)),yes), \
141 $(eval UNSUPPORTED_FEATURES += $(p)=yes), \
142 $(eval override $(p) := no)))
143endef
144
Nico Huber29c68342021-06-27 14:34:16 +0200145define filter_deps
146$(strip $(foreach p,$1, \
147 $(if $(filter $($(p)),yes), \
148 $(p))))
149endef
150
Nico Hubera54f5a42021-06-27 14:27:41 +0200151define disable_all
152$(foreach p,$1, \
153 $(eval override $(p) := no))
154endef
155
156ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
157$(call disable_all,$(DEPENDS_ON_LIBUSB1))
158endif
159
160ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
161$(call disable_all,$(DEPENDS_ON_LIBPCI))
162endif
163
Nico Huber7f898972021-06-27 13:30:50 +0200164###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000165# General OS-specific settings.
166# 1. Prepare for later by gathering information about host and target OS
167# 2. Set compiler flags and parameters according to OSes
168# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000169
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000170# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000171HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100172ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000173# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
174CC = gcc
175endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100176
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000177ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000178STRIP_ARGS = -s
179endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000180
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000181# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000182# IMPORTANT: The following line must be placed before TARGET_OS is ever used
183# (of course), but should come after any lines setting CC because the line
184# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900185override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
186 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000187
188ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000189override CPPFLAGS += -I/opt/local/include -I/usr/local/include
190override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000191endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000192
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000193ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000194override CPPFLAGS += -I/usr/local/include
195override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000196endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000197
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000198ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000199override CPPFLAGS += -I/usr/local/include
200override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000201endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000202
Stefan Taunerc65b8552013-09-12 15:48:39 +0000203ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000204# Needs special `pciutils/pci.h` for older NetBSD packages
205PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
206override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000207override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000208endif
209
210ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000211override CPPFLAGS += -I/usr/local/include
212override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000213endif
214
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000215ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000216EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000217# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000218override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000219LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200220# Missing serial support.
221$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
222# Libraries not available for DOS
223$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000224endif
Ollie Lho184a4042005-11-26 21:55:36 +0000225
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000226# FIXME: Should we check for Cygwin/MSVC as well?
227ifeq ($(TARGET_OS), MinGW)
228EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000229# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000230FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000231# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000232# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000233FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100234
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000235# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200236$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
237# And programmers that need raw access.
238$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000239
Nico Huberca621782021-06-27 13:53:49 +0200240else # No MinGW
241
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100242# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200243$(call mark_unsupported,CONFIG_NI845X_SPI)
244
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100245endif
246
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000247ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000248ifeq ($(MAKECMDGOALS),)
249.DEFAULT_GOAL := libflashrom.a
250$(info Setting default goal to libflashrom.a)
251endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000252FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200253$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000254# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200255$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000256# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200257$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100258# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200259$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000260endif
261
Nico Huberdc8e54a2021-06-27 14:17:34 +0200262# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
263ifeq ($(filter $(TARGET_OS),Linux Android), )
264$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
265$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000266endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000267
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000268ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200269# Android on x86 (currently) does not provide raw PCI port I/O operations.
270$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000271endif
272
Stefan Tauner037cd842013-08-25 00:10:56 +0000273###############################################################################
274# General architecture-specific settings.
275# Like above for the OS, below we verify user-supplied options depending on the target architecture.
276
Uwe Hermann44ffd582011-08-20 14:16:00 +0000277# Determine the destination processor architecture.
278# IMPORTANT: The following line must be placed before ARCH is ever used
279# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000280# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900281override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
282 | tail -1 | cut -f 2 -d'"'))
283override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
284 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000285
Nico Huberc8801732017-12-01 18:19:43 +0000286# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
287ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200288$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000289endif
290
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000291# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000292# Right now this means the drivers below only work on x86.
293ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200294$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
295$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
296$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000297endif
298
Nico Huber8945b812021-06-27 14:24:53 +0200299# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
300# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000301# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700302ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200303$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
304$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
305$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000306endif
307
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000308###############################################################################
309# Flash chip drivers and bus support infrastructure.
310
Stefan Tauner4404f732013-09-12 08:28:56 +0000311CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000312 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300313 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100314 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
315 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000316
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000317###############################################################################
318# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000319
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200320LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000321
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000322###############################################################################
323# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000324
Stefan Tauner9b32de92014-08-08 23:52:33 +0000325CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000326
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200327# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
328# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
329# be obtained using util/getrevision.sh, which is the common case during development.
330-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200331VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200332MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000333
Stefan Tauner76347082016-11-27 17:45:49 +0100334SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000335
Stefan Tauner76347082016-11-27 17:45:49 +0100336# Inform user of the version string
Nico Huber26c2c4d2023-01-10 17:45:38 +0100337ifeq ($(filter branch tag,$(MAKECMDGOALS)), )
Stefan Tauner76347082016-11-27 17:45:49 +0100338$(info Replacing all version templates with $(VERSION).)
Nico Huber26c2c4d2023-01-10 17:45:38 +0100339endif
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000340
Stefan Tauner037cd842013-08-25 00:10:56 +0000341###############################################################################
342# Default settings of CONFIG_* variables.
343
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000344# Always enable internal/onboard support for now.
345CONFIG_INTERNAL ?= yes
346
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000347# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000348CONFIG_SERPROG ?= yes
349
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000350# RayeR SPIPGM hardware support
351CONFIG_RAYER_SPI ?= yes
352
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000353# PonyProg2000 SPI hardware support
354CONFIG_PONY_SPI ?= yes
355
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000356# Always enable 3Com NICs for now.
357CONFIG_NIC3COM ?= yes
358
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000359# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
360CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000361
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000362# Always enable SiI SATA controllers for now.
363CONFIG_SATASII ?= yes
364
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000365# Highpoint (HPT) ATA/RAID controller support.
366# IMPORTANT: This code is not yet working!
367CONFIG_ATAHPT ?= no
368
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000369# VIA VT6421A LPC memory support
370CONFIG_ATAVIA ?= yes
371
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000372# Promise ATA controller support.
373CONFIG_ATAPROMISE ?= no
374
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000375# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000376CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000377
James Lairdc60de0e2013-03-27 13:00:23 +0000378# Always enable Altera USB-Blaster dongles for now.
379CONFIG_USBBLASTER_SPI ?= yes
380
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000381# MSTAR DDC support needs more tests/reviews/cleanups.
382CONFIG_MSTARDDC_SPI ?= no
383
Justin Chevrier66e554b2015-02-08 21:58:10 +0000384# Always enable PICkit2 SPI dongles for now.
385CONFIG_PICKIT2_SPI ?= yes
386
Miklós Márton324929c2019-08-01 19:14:10 +0200387# Always enable STLink V3
388CONFIG_STLINKV3_SPI ?= yes
389
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000390# Always enable dummy tracing for now.
391CONFIG_DUMMY ?= yes
392
393# Always enable Dr. Kaiser for now.
394CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000395
Joerg Fischer5665ef32010-05-21 21:54:07 +0000396# Always enable Realtek NICs for now.
397CONFIG_NICREALTEK ?= yes
398
Andrew Morganc29c2e72010-06-07 22:37:54 +0000399# Disable National Semiconductor NICs until support is complete and tested.
400CONFIG_NICNATSEMI ?= no
401
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000402# Always enable Intel NICs for now.
403CONFIG_NICINTEL ?= yes
404
Idwer Vollering004f4b72010-09-03 18:21:21 +0000405# Always enable SPI on Intel NICs for now.
406CONFIG_NICINTEL_SPI ?= yes
407
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000408# Always enable EEPROM on Intel NICs for now.
409CONFIG_NICINTEL_EEPROM ?= yes
410
Mark Marshall90021f22010-12-03 14:48:11 +0000411# Always enable SPI on OGP cards for now.
412CONFIG_OGP_SPI ?= yes
413
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000414# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000415CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000416
Simon Glassae616512016-01-23 23:27:58 +0000417# Always enable Dediprog SF100 for now.
418CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000419
Daniel Thompson45e91a22018-06-04 13:46:29 +0100420# Always enable Developerbox emergency recovery for now.
421CONFIG_DEVELOPERBOX_SPI ?= yes
422
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000423# Always enable Marvell SATA controllers for now.
424CONFIG_SATAMV ?= yes
425
David Hendricksf9a30552015-05-23 20:30:30 -0700426# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
427CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000428CONFIG_LINUX_SPI ?= yes
429
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000430# Always enable ITE IT8212F PATA controllers for now.
431CONFIG_IT8212 ?= yes
432
Urja Rannikko0870b022016-01-31 22:10:29 +0000433# Winchiphead CH341A
434CONFIG_CH341A_SPI ?= yes
435
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100436# Digilent Development board JTAG
437CONFIG_DIGILENT_SPI ?= yes
438
Jean THOMASe28d8e42022-10-11 17:54:30 +0200439# DirtyJTAG
440CONFIG_DIRTYJTAG_SPI ?= yes
441
Marc Schink3578ec62016-03-17 16:23:03 +0100442# Disable J-Link for now.
443CONFIG_JLINK_SPI ?= no
444
Nico Huber83d52072021-06-27 00:07:13 +0200445# National Instruments USB-845x is Windows only and needs a proprietary library.
446CONFIG_NI845X_SPI ?= no
447
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000448# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000449CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000450
Stefan Taunerf3503372016-02-26 23:51:21 +0000451# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
452ifeq ($(CONFIG_NOTHING), yes)
453 ifeq ($(CONFIG_EVERYTHING), yes)
454 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
455 endif
456 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
457 $(if $(filter yes, $($(var))),\
458 $(eval $(var)=no)))
459endif
460
Patrick Georgiced7ab62015-01-19 19:52:34 +0000461# Enable all features if CONFIG_EVERYTHING=yes is given
462ifeq ($(CONFIG_EVERYTHING), yes)
463$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
464 $(if $(filter no, $($(var))),\
465 $(eval $(var)=yes)))
466endif
467
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000468# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200469
470ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200471override CONFIG_BITBANG_SPI = yes
472else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000473CONFIG_BITBANG_SPI ?= no
474endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000475
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000476###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000477# Handle CONFIG_* variables that depend on others set (and verified) above.
478
479# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
480ifeq ($(TARGET_OS), libpayload)
481ifeq ($(CONFIG_INTERNAL), yes)
482ifeq ($(CONFIG_INTERNAL_DMI), no)
483UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
484else
485override CONFIG_INTERNAL_DMI = yes
486endif
487endif
488endif
489
490# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
491CONFIG_INTERNAL_DMI ?= yes
492
493###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000494# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000495# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000496
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200497ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
498FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
499else
500FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
501endif
502
Stefan Tauner265fcac2014-06-02 00:12:23 +0000503FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000504
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000505ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000506FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000507PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000508ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000509PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200510PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000511ifeq ($(CONFIG_INTERNAL_DMI), yes)
512FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
513endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000514else
515endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000516endif
517
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000518ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000519FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000520PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000521NEED_SERIAL += CONFIG_SERPROG
522NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000523endif
524
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000525ifeq ($(CONFIG_RAYER_SPI), yes)
526FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
527PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000528NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000529endif
530
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000531ifeq ($(CONFIG_PONY_SPI), yes)
532FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
533PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000534NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000535endif
536
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000537ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000538FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000539PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000540endif
541
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000542ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000543FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000544PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000545endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000546
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000547ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000548FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000549PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000550endif
551
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000552ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000553FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000554PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000555endif
556
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000557ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000558FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000559PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000560endif
561
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000562ifeq ($(CONFIG_ATAVIA), yes)
563FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
564PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000565endif
566
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000567ifeq ($(CONFIG_ATAPROMISE), yes)
568FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
569PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000570endif
571
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000572ifeq ($(CONFIG_IT8212), yes)
573FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
574PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000575endif
576
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000577ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000578# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000579FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000580PROGRAMMER_OBJS += ft2232_spi.o
581endif
582
583ifeq ($(CONFIG_USBBLASTER_SPI), yes)
584# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000585FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000586PROGRAMMER_OBJS += usbblaster_spi.o
587endif
588
Justin Chevrier66e554b2015-02-08 21:58:10 +0000589ifeq ($(CONFIG_PICKIT2_SPI), yes)
590FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
591PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000592endif
593
Miklós Márton324929c2019-08-01 19:14:10 +0200594ifeq ($(CONFIG_STLINKV3_SPI), yes)
595FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
596PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200597endif
598
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000599ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000600FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000601PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000602endif
603
604ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000605FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000606PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000607endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000608
Joerg Fischer5665ef32010-05-21 21:54:07 +0000609ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000610FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000611PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000612endif
613
Andrew Morganc29c2e72010-06-07 22:37:54 +0000614ifeq ($(CONFIG_NICNATSEMI), yes)
615FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
616PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000617endif
618
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000619ifeq ($(CONFIG_NICINTEL), yes)
620FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
621PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000622endif
623
Idwer Vollering004f4b72010-09-03 18:21:21 +0000624ifeq ($(CONFIG_NICINTEL_SPI), yes)
625FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
626PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000627endif
628
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000629ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
630FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
631PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000632endif
633
Mark Marshall90021f22010-12-03 14:48:11 +0000634ifeq ($(CONFIG_OGP_SPI), yes)
635FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
636PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000637endif
638
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000639ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
640FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000641PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000642NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000643endif
644
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000645ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000646FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000647PROGRAMMER_OBJS += dediprog.o
648endif
649
Daniel Thompson45e91a22018-06-04 13:46:29 +0100650ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
651FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
652PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100653endif
654
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000655ifeq ($(CONFIG_SATAMV), yes)
656FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
657PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000658endif
659
David Hendricksf9a30552015-05-23 20:30:30 -0700660ifeq ($(CONFIG_LINUX_MTD), yes)
661# This is a totally ugly hack.
662FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
663PROGRAMMER_OBJS += linux_mtd.o
664endif
665
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000666ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000667# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000668FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000669PROGRAMMER_OBJS += linux_spi.o
670endif
671
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000672ifeq ($(CONFIG_MSTARDDC_SPI), yes)
673# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000674FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000675NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000676PROGRAMMER_OBJS += mstarddc_spi.o
677endif
678
Urja Rannikko0870b022016-01-31 22:10:29 +0000679ifeq ($(CONFIG_CH341A_SPI), yes)
680FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
681PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000682endif
683
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100684ifeq ($(CONFIG_DIGILENT_SPI), yes)
685FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
686PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100687endif
688
Jean THOMASe28d8e42022-10-11 17:54:30 +0200689ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
690FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
691PROGRAMMER_OBJS += dirtyjtag_spi.o
692endif
693
Marc Schink3578ec62016-03-17 16:23:03 +0100694ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100695FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
696PROGRAMMER_OBJS += jlink_spi.o
697endif
698
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100699ifeq ($(CONFIG_NI845X_SPI), yes)
700FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
701
702ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
703# if the user did not specified the NI-845x headers/lib path
704# do a guess for both 32 and 64 bit Windows versions
705NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100706NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200707
708# hack to access env variable containing brackets...
709PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
710
711ifneq ($(PROGRAMFILES_X86DIR),)
712ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
713NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
714NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
715endif
716endif
717
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100718else
719NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
720NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
721endif
722
723FEATURE_CFLAGS += $(NI845X_INCLUDES)
724LIBS += -lni845x
725PROGRAMMER_OBJS += ni845x_spi.o
726endif
727
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000728ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200729LIB_OBJS += serial.o
730ifeq ($(TARGET_OS), Linux)
731LIB_OBJS += custom_baud_linux.o
732else
733LIB_OBJS += custom_baud.o
734endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000735endif
736
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000737ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000738ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000739LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000740endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000741endif
742
Nico Huberf55ca202021-06-27 14:36:06 +0200743NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000744ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000745CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000746# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
747# libpci may need raw memory, MSR or PCI port I/O on some platforms.
748# Individual drivers might have the same needs as well.
749NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000750FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000751FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000752
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000753PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000754ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000755# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000756PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000757else
758PCILIBS += -lpci
759endif
760endif
761
762ifneq ($(NEED_RAW_ACCESS), )
763# Raw memory, MSR or PCI port I/O access.
764FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
765PROGRAMMER_OBJS += physmap.o hwaccess.o
766
767ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200768ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000769PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200770endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000771else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000772ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200773ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000774PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200775endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000776else
777ifeq ($(TARGET_OS), Darwin)
778# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000779PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000780endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000781endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000782endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000783
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000784endif
785
Nico Huberf55ca202021-06-27 14:36:06 +0200786NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000787ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000788CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100789PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000790# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
791ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
792USB1LIBS += -lusb
793else
794ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000795override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000796USB1LIBS += -lusb-1.0
797else
Stefan Tauner45207062016-02-19 08:17:24 +0000798USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
799override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000800endif
801endif
802endif
803
Nico Huberf55ca202021-06-27 14:36:06 +0200804NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200805ifneq ($(NEED_LIBFTDI), )
806FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
807FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
808FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
809FEATURE_CFLAGS += $(FTDI_INCLUDES)
810FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
811# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
812# into a hard requirement for libusb, defeating the purpose of auto-enabling.
813endif
814
Nico Huberf55ca202021-06-27 14:36:06 +0200815NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100816ifneq ($(NEED_LIBJAYLINK), )
817CHECK_LIBJAYLINK = yes
818JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
819override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
820endif
821
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000822ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000823FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000824CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000825endif
826
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000827FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000828
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000829# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000830FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000831
Nico Huber8624e8c2012-11-05 21:46:33 +0100832FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
833FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
834
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000835LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000836OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000837
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000838all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000839ifeq ($(ARCH), x86)
840 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
841endif
842
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000843$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100844 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000845
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000846libflashrom.a: $(LIBFLASHROM_OBJS)
847 $(AR) rcs $@ $^
848 $(RANLIB) $@
849
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000850# TAROPTIONS reduces information leakage from the packager's system.
851# If other tar programs support command line arguments for setting uid/gid of
852# stored files, they can be handled here as well.
853TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000854
Paul Fox05dfbe62009-06-16 21:08:06 +0000855%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100856 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000857
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000858# Make sure to add all names of generated binaries here.
859# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000860# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000861clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000862 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000863 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000864
Ollie Lho184a4042005-11-26 21:55:36 +0000865distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000866 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000867
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000868strip: $(PROGRAM)$(EXEC_SUFFIX)
869 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000870
Stefan Tauner56787082011-08-18 02:27:19 +0000871# to define test programs we use verbatim variables, which get exported
872# to environment variables and are referenced with $$<varname> later
873
874define COMPILER_TEST
875int main(int argc, char **argv)
876{
877 (void) argc;
878 (void) argv;
879 return 0;
880}
881endef
882export COMPILER_TEST
883
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000884compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000885 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000886 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000887 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000888 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
889 echo "found." || { echo "not found."; \
890 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000891 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000892 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000893 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000894 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900895 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000896 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000897 @printf "Target OS is "
898 @# FreeBSD wc will output extraneous whitespace.
899 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900900 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000901 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000902ifeq ($(TARGET_OS), libpayload)
903 @$(CC) --version 2>&1 | grep -q coreboot || \
904 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
905 echo "This might work but usually does not, please beware." )
906endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000907
Stefan Tauner56787082011-08-18 02:27:19 +0000908define LIBPCI_TEST
909/* Avoid a failing test due to libpci header symbol shadowing breakage */
910#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000911#if !defined PCIUTILS_PCI_H
Stefan Tauner56787082011-08-18 02:27:19 +0000912#include <pci/pci.h>
Stefan Taunerc65b8552013-09-12 15:48:39 +0000913#else
914#include <pciutils/pci.h>
915#endif
Stefan Tauner56787082011-08-18 02:27:19 +0000916struct pci_access *pacc;
917int main(int argc, char **argv)
918{
919 (void) argc;
920 (void) argv;
921 pacc = pci_alloc();
922 return 0;
923}
924endef
925export LIBPCI_TEST
926
Stefan Tauner56734502015-02-08 21:58:04 +0000927define PCI_GET_DEV_TEST
928/* Avoid a failing test due to libpci header symbol shadowing breakage */
929#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000930#if !defined PCIUTILS_PCI_H
Stefan Tauner56734502015-02-08 21:58:04 +0000931#include <pci/pci.h>
932#else
933#include <pciutils/pci.h>
934#endif
935struct pci_access *pacc;
936struct pci_dev *dev = {0};
937int main(int argc, char **argv)
938{
939 (void) argc;
940 (void) argv;
941 pacc = pci_alloc();
942 dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
943 return 0;
944}
945endef
946export PCI_GET_DEV_TEST
947
Stefan Taunere49edbb2016-01-31 22:10:14 +0000948define LIBUSB1_TEST
949#include <stddef.h>
950#include <libusb.h>
951int main(int argc, char **argv)
952{
953 (void)argc;
954 (void)argv;
955 libusb_init(NULL);
956 return 0;
957}
958endef
959export LIBUSB1_TEST
960
Marc Schink3578ec62016-03-17 16:23:03 +0100961define LIBJAYLINK_TEST
962#include <stddef.h>
963#include <libjaylink/libjaylink.h>
964int main(int argc, char **argv)
965{
966 struct jaylink_context *ctx;
967
968 (void)argc;
969 (void)argv;
970
971 jaylink_init(&ctx);
972 jaylink_exit(ctx);
973
974 return 0;
975}
976endef
977export LIBJAYLINK_TEST
978
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000979hwlibs: compiler
980 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000981ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000982 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000983 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000984 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000985 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
986 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000987 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000988 echo "Please install libpci headers or disable all features"; \
989 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000990 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000991 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
992 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000993 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000994 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000995 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000996 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000997 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
998 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000999 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001000 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
1001 echo "yes." || { echo "no."; \
1002 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001003 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
1004 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001005 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001006 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001007 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
1008 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001009 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001010 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001011 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001012endif
Stefan Taunere49edbb2016-01-31 22:10:14 +00001013ifeq ($(CHECK_LIBUSB1), yes)
1014 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
1015 @echo "$$LIBUSB1_TEST" > .test.c
1016 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1017 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1018 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001019 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001020 echo "Please install libusb-1.0 headers or disable all features"; \
1021 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001022 echo "See README for more information."; echo; \
1023 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1024 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
1025 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
1026 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
1027 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001028 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001029 echo "Please install libusb-1.0 or disable all features"; \
1030 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001031 echo "See README for more information."; echo; \
1032 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1033 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1034endif
Marc Schink3578ec62016-03-17 16:23:03 +01001035ifeq ($(CHECK_LIBJAYLINK), yes)
1036 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
1037 @echo "$$LIBJAYLINK_TEST" > .test.c
1038 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1039 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1040 echo "found." || { echo "not found."; echo; \
1041 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1042 echo "Please install libjaylink headers or disable the feature"; \
1043 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1044 echo "See README for more information."; echo; \
1045 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1046 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
1047 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
1048 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
1049 echo "yes." || { echo "no."; \
1050 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1051 echo "Please install libjaylink or disable the feature"; \
1052 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1053 echo "See README for more information."; echo; \
1054 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1055 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1056endif
Stefan Reinauer53e96252005-12-01 16:19:24 +00001057
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001058.features: features
1059
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001060# If a user does not explicitly request a non-working feature, we should
1061# silently disable it. However, if a non-working (does not compile) feature
1062# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001063# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001064featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001065ifeq ($(PROGRAMMER_OBJS),)
1066 @echo "You have to enable at least one programmer driver!"
1067 @false
1068endif
1069ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001070 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
1071 @false
1072endif
1073
Stefan Tauner56787082011-08-18 02:27:19 +00001074define FTDI_TEST
Stefan Tauner5c316f92015-02-08 21:57:52 +00001075#include <stdlib.h>
Stefan Tauner56787082011-08-18 02:27:19 +00001076#include <ftdi.h>
1077struct ftdi_context *ftdic = NULL;
1078int main(int argc, char **argv)
1079{
1080 (void) argc;
1081 (void) argv;
1082 return ftdi_init(ftdic);
1083}
1084endef
1085export FTDI_TEST
1086
Ilya A. Volynets-Evenbakh2c714ab2012-09-26 00:47:09 +00001087define FTDI_232H_TEST
1088#include <ftdi.h>
1089enum ftdi_chip_type type = TYPE_232H;
1090endef
1091export FTDI_232H_TEST
1092
Stefan Tauner56787082011-08-18 02:27:19 +00001093define UTSNAME_TEST
1094#include <sys/utsname.h>
1095struct utsname osinfo;
1096int main(int argc, char **argv)
1097{
1098 (void) argc;
1099 (void) argv;
1100 uname (&osinfo);
1101 return 0;
1102}
1103endef
1104export UTSNAME_TEST
1105
David Hendricksf9a30552015-05-23 20:30:30 -07001106define LINUX_MTD_TEST
1107#include <mtd/mtd-user.h>
1108
1109int main(int argc, char **argv)
1110{
1111 (void) argc;
1112 (void) argv;
1113 return 0;
1114}
1115endef
1116export LINUX_MTD_TEST
1117
Stefan Tauner8868db32012-03-13 00:18:19 +00001118define LINUX_SPI_TEST
1119#include <linux/types.h>
1120#include <linux/spi/spidev.h>
1121
1122int main(int argc, char **argv)
1123{
1124 (void) argc;
1125 (void) argv;
1126 return 0;
1127}
1128endef
1129export LINUX_SPI_TEST
1130
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001131define LINUX_I2C_TEST
1132#include <linux/i2c-dev.h>
1133#include <linux/i2c.h>
1134
1135int main(int argc, char **argv)
1136{
1137 (void) argc;
1138 (void) argv;
1139 return 0;
1140}
1141endef
1142export LINUX_I2C_TEST
1143
Nico Huber8624e8c2012-11-05 21:46:33 +01001144define CLOCK_GETTIME_TEST
1145#include <time.h>
1146
1147int main(int argc, char **argv)
1148{
1149 struct timespec res;
1150 clock_gettime(CLOCK_REALTIME, &res);
1151 return 0;
1152}
1153endef
1154export CLOCK_GETTIME_TEST
1155
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001156define NI845X_TEST
1157#include <ni845x.h>
1158
1159int main(int argc, char **argv)
1160{
1161 (void) argc;
1162 (void) argv;
1163 char I2C_Device[256];
1164 NiHandle Dev_Handle;
1165 uInt32 NumberFound = 0;
1166 ni845xFindDevice(I2C_Device, &Dev_Handle, &NumberFound);
1167 ni845xCloseFindDeviceHandle(Dev_Handle);
1168 return 0;
1169}
1170endef
1171export NI845X_TEST
1172
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001173features: compiler
1174 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001175ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001176 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001177 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001178 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001179 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1180 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
1181 printf "Checking for FT232H support in libftdi... " ; \
1182 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001183 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001184 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1185 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
1186 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
1187 ) || \
1188 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
1189 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001190endif
David Hendricksf9a30552015-05-23 20:30:30 -07001191ifeq ($(CONFIG_LINUX_MTD), yes)
1192 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1193 @echo "$$LINUX_MTD_TEST" > .featuretest.c
1194 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1195 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1196 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1197 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1198 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1199endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001200ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001201 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001202 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001203 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001204 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001205 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001206 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1207 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001208endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001209ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001210 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001211 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001212 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001213 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001214 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001215 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1216 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001217endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001218ifeq ($(CONFIG_NI845X_SPI), yes)
1219 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1220 @echo "$$NI845X_TEST" > .featuretest.c
1221 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1222
1223 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1224 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1225 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1226 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1227 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1228 echo "For the NI-845x 17.0 the library path is:"; \
1229 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1230 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1231 exit 1; }; } \
1232 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1233endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001234 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001235 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001236 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001237 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001238 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001239 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001240 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001241ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1242 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1243 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1244else
Nico Huber8624e8c2012-11-05 21:46:33 +01001245 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1246 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1247 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1248 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1249 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1250 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001251endif
Stefan Tauner56787082011-08-18 02:27:19 +00001252 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1253 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001254
Stefan Tauner4c723152016-01-14 22:47:55 +00001255$(PROGRAM).8.html: $(PROGRAM).8
1256 @groff -mandoc -Thtml $< >$@
1257
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001258$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001259 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001260 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001261
1262install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001263 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001264 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001265 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001266 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001267
Nico Huber454f6132012-12-10 13:34:10 +00001268libinstall: libflashrom.a libflashrom.h
1269 mkdir -p $(DESTDIR)$(PREFIX)/lib
1270 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1271 mkdir -p $(DESTDIR)$(PREFIX)/include
1272 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1273
Nico Huber5f245a22023-01-10 17:14:47 +01001274versioninfo:
1275# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1276 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1277 @echo "VERSION = $(RELEASE)" > $@.inc
1278 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1279
Nico Huber26c2c4d2023-01-10 17:45:38 +01001280branch: versioninfo
1281 @git checkout -b $(RELEASE)
1282 @git add -f $<.inc
1283 @git commit -sm'Update version info for $(RELEASE)'
1284
1285tag: versioninfo
1286 @git add -f $<.inc
1287 @git commit -sm'Update version info for $(RELEASE)'
1288 @git tag -s $(RELEASE)
1289
Nico Huber5f245a22023-01-10 17:14:47 +01001290# No spaces in release names unless set explicitly
Nico Huber1d58a902023-01-10 18:26:12 +01001291RELEASENAME ?= flashrom-stable-$(shell echo "$(VERSION)" | sed -e 's/ /_/')
Nico Huber5f245a22023-01-10 17:14:47 +01001292
Nico Huber1d58a902023-01-10 18:26:12 +01001293_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001294_export: $(PROGRAM).8
Nico Huber1d58a902023-01-10 18:26:12 +01001295 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1296 @mkdir -p "$(EXPORTDIR)/$(RELEASENAME)"
1297 @git archive HEAD | tar -x -C "$(EXPORTDIR)/$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001298# Generate fresh versioninfo.inc and compare
1299 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1300 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1301 "$(EXPORT_VERSIONINFO)"
1302 @if [ -f versioninfo.inc ]; then \
1303 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1304 { echo Error: Version info changed:; \
1305 cat "$(EXPORT_VERSIONINFO)"; \
1306 echo Update versioninfo.inc and tag accordingly.; \
1307 exit 1; \
1308 }; \
1309 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001310# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1311# sed is required to filter out file names having the attribute set.
1312# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1313# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001314 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1315 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001316 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001317 xargs -0 sh -c 'for f; do \
1318 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
Nico Huber1d58a902023-01-10 18:26:12 +01001319 "$(EXPORTDIR)/$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001320 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001321
Stefan Tauner76347082016-11-27 17:45:49 +01001322export: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001323 @echo "Exported $(EXPORTDIR)/$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001324
1325tarball: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001326 @tar -cj --format=ustar -f "$(EXPORTDIR)/$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
1327 $(TAROPTIONS) "$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001328# Delete the exported directory again because it is most likely what's expected by the user.
Nico Huber1d58a902023-01-10 18:26:12 +01001329 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1330 @echo Created "$(EXPORTDIR)/$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001331
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001332libpayload: clean
1333 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001334
Felix Singer9441c6e2022-10-21 12:47:11 +02001335gitconfig:
1336 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1337
Nico Huber26c2c4d2023-01-10 17:45:38 +01001338.PHONY: all install clean distclean compiler hwlibs features branch tag versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001339
Stefan Tauner23e10b82016-01-23 16:16:49 +00001340# Disable implicit suffixes and built-in rules (for performance and profit)
1341.SUFFIXES:
1342
Stefan Reinauere2f01582010-06-07 11:08:07 +00001343-include $(OBJS:.o=.d)